/**
 * 入口函数
 * @param {Object} jsonData
 */
define(function() {
	var oldBroadQueryView = null;
	var oldSpecificQueryView = null;

	function showMovieView(jsonResult) {
		log("showMovieView()");
		var dataType = jsonResult.queryType;
		var data = jsonResult.data;
		var resultView;
		switch(dataType) {
			case "broadQuery":
				resultView = createMovieBroadQueryView(data);
				break;
			case "specificQuery":
				resultView = createMovieSpecificQueryView(data);
				break;
		}
		return resultView;

	}

	///////////////////////////宽泛查询页面开始///////////////////////////
	// 正在上映
	var releasedType = "released";
	var releasedTotalServerPages = 0;
	var releasedCurrentServerPage = 0;
	var releasedData = {
		"data" : {}
	};
	// 即将上映
	var beReleaseType = "berelease";
	var bereleaseTotalServerPages = 0;
	var bereleaseCurrentServerPage = 0;
	var bereleaseData = {
		"data" : {}
	};
	var videoTaskHandler;
	// 页面显示标记
	var movie_items_content_show_flag = "movie_items_show_flag";
	// 页面隐藏标记
	var movie_items_content_hidden_flag = "movie_items_hidden_flag";
	var movie_item_class_name = "css_moive_item_div";
	// 电影海报
	var film_poster_class_name = "css_film_poster_img";
	// 电影名称
	var movie_name_class_name = "css_movie_name_label";
	var movie_name_comming_class_name = "css_movie_name_comming_label";
	// 上映时间
	var movie_release_date_class_name = "css_movie_release_date_label";
	var movie_release_date_comming_class_name = "css_movie_release_date_comming_label";
	// 电影星级
	var movie_stars_class_name = "css_movie_stars_div";
	// 电影评分
	var movie_grade_class_name = "css_movie_grade_label";
	// 每页电影条目数
	var defaultItems = 4;
	// 是否从服务端完成数据获取
	var isObtainPlayingDataComplete = true;
	var isObtainCommingDataComplete = true;
	// 正在上映是否加载下一页数据
	var isNeedLoadNextPalyingPage = false;
	// 即将上映是否加载下一页数据
	var isNeedLoadNextCommingPage = false;
	// 等待加载页面在类型
	var beLoadType = null;
	// 等待加载的正在上映页码
	var beLoadPalyingPage = 0;
	// 等待加载的正在上映页码
	var beLoadCommingPage = 0;

	var palying_loading_update_id = null;
	var comming_loading_update_id = null;

	/**
	 * 创建宽泛查询界面
	 * @param {Object} data
	 */
	function createMovieBroadQueryView(data) {
		// 删除老的View
		if (oldBroadQueryView != null && oldBroadQueryView.parentNode == document.body) {
			removeChild(document.body, oldBroadQueryView);
			oldBroadQueryView = null;
			reSet();
			// 调用java函数释放底层资源
			// exec(*, *, *);
		}

		init(data);
		var outDiv = createOutDiv();

		var broad_query_view_container = document.createElement("div");
		broad_query_view_container.className = "css_broad_query_view_container_div";
		// var broad_query_view_container = document.getElementById("title");

		/* 上部分 */
		var broad_query_view_top = document.createElement("div");
		broad_query_view_top.className = "css_broad_query_view_div";
		var top_menus = createTopMenus();
		broad_query_view_top.appendChild(top_menus);

		/* 下部分 包括 正在上映和 即将上映两部分 */
		var broad_query_view_bottom = document.createElement("div");

		// 正在上映
		var broad_query_released = document.createElement("div");
		broad_query_released.className = movie_items_content_hidden_flag;
		broad_query_released.id = movie_items_content_show_flag;

		var released_content_container = document.createElement("div");
		released_content_container.id = "id_released_content_container";
		// dialog
		var palyingDialogView = createDialogView("id_palying_dialog", "id_playing_canvas", "id_palying_refresh", "id_palying_failertext");

		// 首次显示正在上映
		var released_content_items = createContentItems(releasedType);
		released_content_container.appendChild(palyingDialogView);
		released_content_container.appendChild(released_content_items);

		var released_content_navigation_bar = createContentNavigationBar(releasedData.data);
		broad_query_released.appendChild(released_content_container);
		broad_query_released.appendChild(released_content_navigation_bar);

		// 即将上映
		var broad_query_berelease = document.createElement("div");
		broad_query_berelease.className = movie_items_content_hidden_flag;

		var berelease_content_container = document.createElement("div");
		berelease_content_container.id = "id_berelease_content_container";
		// dialog
		var commingDialogView = createDialogView("id_comming_dialog", "id_comming_canvas", "id_comming_refresh", "id_comming_failertext");
		var berelease_content_items = createContentItems(beReleaseType);
		berelease_content_container.appendChild(commingDialogView);
		berelease_content_container.appendChild(berelease_content_items);

		var berelease_content_navigation_bar = createContentNavigationBar(bereleaseData.data);
		broad_query_berelease.appendChild(berelease_content_container);
		broad_query_berelease.appendChild(berelease_content_navigation_bar);

		broad_query_view_bottom.appendChild(broad_query_released);
		broad_query_view_bottom.appendChild(broad_query_berelease);

		var touchObj = createHandleTouchObject(movie_item_class_name, film_poster_class_name);
		enableScrollTouchEvent(released_content_items, 15, touchObj);
		enableScrollTouchEvent(berelease_content_items, 15, touchObj);
		released_content_items.addEventListener("scrolltouch", function() {
			exec(videoTaskHandler, 'statistic', ["ITEMS_CLICKED"]);
			exec(videoTaskHandler, 'launcherFilm', [touchObj.returnArgument]);
		}, false);
		berelease_content_items.addEventListener("scrolltouch", function() {
			exec(videoTaskHandler, 'statistic', ["ITEMS_CLICKED"]);
			exec(videoTaskHandler, 'launcherFilm', [touchObj.returnArgument]);
		}, false);

		broad_query_view_container.appendChild(broad_query_view_top);
		broad_query_view_container.appendChild(broad_query_view_bottom);

		initItemsView(released_content_items, releasedData.data, releasedType);
		initItemsView(berelease_content_items, bereleaseData.data, beReleaseType);
		outDiv.appendChild(broad_query_view_container);

		document.body.appendChild(outDiv);
		oldBroadQueryView = outDiv;

		showOpacityAnimation(outDiv, 150);
		exec(videoTaskHandler, 'statistic', ["SHOW_PLAYING"]);
		return outDiv;
	}

	/**
	 * 初始化
	 * 保存第一次从服务端的数据
	 */
	function init(data) {
		releasedData.data = data.nowplaying;
		bereleaseData.data = data.coming;
		releasedType = releasedData.data.type;
		beReleaseType = bereleaseData.data.type;
		releasedTotalServerPages = releasedData.data.totalServerPages;
		releasedCurrentServerPage = releasedData.data.currentServerPage;
		bereleaseTotalServerPages = bereleaseData.data.totalServerPages
		bereleaseCurrentServerPage = bereleaseData.data.currentServerPage;
		videoTaskHandler = data.taskHandler;
		// other...
	}

	/**
	 * 重置被初始的参数
	 */
	function reSet() {
		releasedData.data = '';
		bereleaseData.data = '';
		//releasedType = '';
		//beReleaseType = '';
		releasedTotalServerPages = 0;
		releasedCurrentServerPage = 0;
		bereleaseTotalServerPages = 0;
		bereleaseCurrentServerPage = 0;
		videoTaskHandler = '';
		isObtainPlayingDataComplete = true;
		isObtainCommingDataComplete = true;
		isNeedLoadNextPalyingPage = false;
		isNeedLoadNextCommingPage = false;
		beLoadType = null;
		beLoadPalyingPage = 0;
		beLoadCommingPage = 0;

		palying_loading_update_id = null;
		comming_loading_update_id = null;
	}

	function createDialogView(dialogId, canvasId, refreshId, failerTextId) {
		// loading 状态下的显示元素
		var dialog_movies_loading_div = document.createElement("div");
		dialog_movies_loading_div.id = dialogId;
		dialog_movies_loading_div.style.display = "none";
		dialog_movies_loading_div.className = "css_dialog_movies_loading";
		// loading使用canvas模拟
		var dialog_movies_loading_canvas = document.createElement("canvas");
		dialog_movies_loading_canvas.id = canvasId;
		// FIXME 暂时借用dialog_title_canvas_height的值作为canvas的宽、高，后续使用独立的变量
		dialog_movies_loading_canvas.setAttribute("width", dialog_title_canvas_height + "px");
		dialog_movies_loading_canvas.setAttribute("height", dialog_title_canvas_height + "px");
		var refreshImg = document.createElement("img");
		refreshImg.src = dialog_stock_refresh;
		refreshImg.className = "css_dialog_refresh_img";
		refreshImg.id = refreshId;
		refreshImg.addEventListener("touchstart", function() {
			refreshEvent(event);
		});
		var dialog_movies_loading_failertext = document.createElement("div");
		dialog_movies_loading_failertext.setAttribute("id", failerTextId);
		dialog_movies_loading_failertext.className = "css_dialog_movies_loading_failertext";
		dialog_movies_loading_failertext.innerText = "网络连接超时，请稍后重试";

		dialog_movies_loading_div.appendChild(dialog_movies_loading_canvas);
		dialog_movies_loading_div.appendChild(refreshImg);
		dialog_movies_loading_div.appendChild(dialog_movies_loading_failertext);

		return dialog_movies_loading_div;
	}

	function refreshEvent(event) {
		var target = event.target;
		if (target.id == "id_palying_refresh") {
			getDataFromServer(releasedType, parseInt(releasedCurrentServerPage) + 1, releasedData.data.dataSourceId, releasedData.data.dataSourceName);
			isObtainPlayingDataComplete = false;
		} else if (target.id == "id_comming_refresh") {
			getDataFromServer(beReleaseType, parseInt(bereleaseCurrentServerPage) + 1, bereleaseData.data.dataSourceId, bereleaseData.data.dataSourceName);
			isObtainCommingDataComplete = false;
		}
	}

	/**
	 * 设置指定页面内容
	 */
	function initItemsView(itemsView, itemsValue, pageType) {
		var movies = itemsValue.movies;
		var movieItems = itemsView.getElementsByClassName(movie_item_class_name);

		for (var i = 0; i < defaultItems; i++) {
			var movieValue = movies[i];
			if (movieValue != undefined && movieValue != null) {
				movieItems[i].style.display = "inline-block";
				movieItems[i].getElementsByClassName(film_poster_class_name)[0].src = movieValue.filmPoster;
				movieItems[i].getElementsByClassName(film_poster_class_name)[0].id = movieValue.detailUrl;
				movieItems[i].getElementsByClassName(movie_release_date_class_name)[0].innerText = "上映时间：" + movieValue.releaseDate;
				if (pageType == beReleaseType) {
					movieItems[i].getElementsByClassName(movie_name_comming_class_name)[0].innerText = movieValue.name;

				} else if (pageType == releasedType) {
					movieItems[i].getElementsByClassName(movie_name_class_name)[0].innerText = movieValue.name;
					var movieItemStars = createStars(movieValue.level);
					movieItems[i].getElementsByClassName(movie_stars_class_name)[0].innerHTML = movieItemStars.innerHTML;
					movieItems[i].getElementsByClassName(movie_grade_class_name)[0].innerText = movieValue.grade;
				}
			} else {
				movieItems[i].style.display = "none";
			}
		}
	}

	function setContentItemsValue(pageType, values) {
		if (values == undefined || values == null) {
			return;
		}
		var itemsContainer = document.getElementById(movie_items_content_show_flag);
		if (pageType == releasedType) {
			itemsContainer = document.getElementById("id_released_content_container");
		} else if (pageType == beReleaseType) {
			itemsContainer = document.getElementById("id_berelease_content_container");
		}

		initItemsView(itemsContainer, values, pageType);

	}

	/**
	 *创建内容条目
	 */
	function createContentItems(pageType) {
		var movie_items = document.createElement("div");
		movie_items.className = "css_movie_items_div";
		for (var i = 0; i < defaultItems; i++) {
			var movieItem = document.createElement("div");
			movieItem.className = movie_item_class_name;
			var itemContent = document.createElement("div");

			// 电影明细左部分
			var movieItemLeft = document.createElement("div");
			movieItemLeft.className = "css_movie_item_left_div";
			var filmPoster = document.createElement("img");
			filmPoster.className = film_poster_class_name;
			filmPoster.addEventListener("error", function() {
				this.src = movie_broad_filmposter_default;
			}, false);
			movieItemLeft.appendChild(filmPoster);

			// 电影明细中部分
			var movieItemMiddle = document.createElement("div");
			movieItemMiddle.className = "css_movie_item_middle_div";
			var movieNamePackage = document.createElement("div");
			var movieName = document.createElement("label");
			movieName.className = movie_name_class_name;
			movieNamePackage.appendChild(movieName);

			var movieReleaseDatePackage = document.createElement("div");
			movieReleaseDatePackage.className = "css_movie_release_date_package_div";
			var movieReleaseDate = document.createElement("label");
			movieReleaseDate.className = movie_release_date_class_name;
			movieReleaseDatePackage.appendChild(movieReleaseDate);

			var emptyDiv = document.createElement("div");
			movieItemMiddle.appendChild(emptyDiv);
			movieItemMiddle.appendChild(movieNamePackage);
			movieItemMiddle.appendChild(movieReleaseDatePackage);

			if (pageType == releasedType) {
				var movieStarsAndGrade = document.createElement("div");
				movieStarsAndGrade.className = "css_movie_stars_and_grade_div";
				var movieStars = document.createElement("div");
				movieStars.className = movie_stars_class_name;
				var movieGrade = document.createElement("label");
				movieGrade.className = movie_grade_class_name;
				movieStarsAndGrade.appendChild(movieStars);
				movieStarsAndGrade.appendChild(movieGrade);
				movieItemMiddle.appendChild(movieStarsAndGrade);
			} else if (pageType == beReleaseType) {
				movieName.className = movie_name_comming_class_name;
				movieReleaseDatePackage.className = "css_movie_release_date_comming_package_div";
			}

			// 电影明细右部分
			var movieItemRight = document.createElement("div");
			movieItemRight.className = "css_movie_item_right_div";
			linkImg = document.createElement("img");
			linkImg.className = "css_link_img";
			linkImg.src = movie_broad_query_item_arrow;
			movieItemRight.appendChild(linkImg);

			itemContent.appendChild(movieItemLeft);
			itemContent.appendChild(movieItemMiddle);
			itemContent.appendChild(movieItemRight);

			var itemBaseline = document.createElement("div");
			itemBaseline.className = "css_item_baseline_div";

			movieItem.appendChild(itemContent);
			movieItem.appendChild(itemBaseline);
			movie_items.appendChild(movieItem);
		}
		return movie_items;
	}

	/**
	 * 宽泛查询
	 * 创建翻页栏
	 */
	function createContentNavigationBar(data) {
		var dataType = data.type;
		var content_navigation_bar = document.createElement("div");
		content_navigation_bar.className = "css_content_navigation_bar_div";
		var page_up = document.createElement("img");
		page_up.className = "css_page_up_img";
		page_up.src = movie_broad_query_bigarrow_left_dark;
		var page_indicator = document.createElement("label");
		page_indicator.className = "css_page_indicator_label";
		page_indicator.innerText = "1/" + data.totalPage;
		page_indicator.id = (dataType == releasedType) ? "indicator_released" : "indicator_berelease";

		var page_down = document.createElement("img");
		page_down.className = "css_page_down_img";
		page_down.src = movie_broad_query_bigarrow_right;
		// 组装
		content_navigation_bar.appendChild(page_up);
		content_navigation_bar.appendChild(page_indicator);
		content_navigation_bar.appendChild(page_down);
		content_navigation_bar.addEventListener("touchstart", function() {
			var target = event.target;
			if (target.className == "css_page_up_img" && target.src != movie_broad_query_bigarrow_left_dark) {
				target.src = movie_broad_query_bigarrow_left_clicked;
			} else if (target.className == "css_page_down_img" && target.src != movie_broad_query_bigarrow_right_dark) {
				target.src = movie_broad_query_bigarrow_right_clicked;
			}
		});
		content_navigation_bar.addEventListener("touchmove", function() {
			var target = event.target;
			if (target.className == "css_page_up_img" && target.src != movie_broad_query_bigarrow_left_dark) {
				target.src = movie_broad_query_bigarrow_left;
			} else if (target.className == "css_page_down_img" && target.src != movie_broad_query_bigarrow_right_dark) {
				target.src = movie_broad_query_bigarrow_right;
			}
		});
		content_navigation_bar.addEventListener("touchend", function() {
			var target = event.target;
			if (target.className == "css_page_up_img" && target.src != movie_broad_query_bigarrow_left_dark) {
				target.src = movie_broad_query_bigarrow_left;
			} else if (target.className == "css_page_down_img" && target.src != movie_broad_query_bigarrow_right_dark) {
				target.src = movie_broad_query_bigarrow_right;
			}
			pagging(dataType, event);
		}, false);

		return content_navigation_bar;
	}

	/**
	 * 宽泛查询
	 * 处理翻页
	 */
	function pagging(type, event) {
		var targetElement = event.target;
		var targetClassName = targetElement.className;
		var indicator = document.getElementById("indicator_released");
		if (type == beReleaseType) {
			indicator = document.getElementById("indicator_berelease");
		}
		var indicatorInfo = indicator.innerText.split("/");
		var currentPage = parseInt(indicatorInfo[0]);
		var totalPages = parseInt(indicatorInfo[1]);
		if (targetClassName == "css_page_up_img" && currentPage > 1) {
			if (type == releasedType) {
				isNeedLoadNextPalyingPage = false;
			} else if (type == beReleaseType) {
				isNeedLoadNextCommingPage = false;
			}
			completeStoreData(type);
			var previousPageData = getDataFromCache(type, currentPage - 1);
			setContentItemsValue(type, previousPageData);
			exec(videoTaskHandler, 'statistic', ["PAGGING_CLICKED"]);
			indicator.innerText = (currentPage - 1) + "/" + totalPages;
			if (currentPage == 2) {
				targetElement.src = movie_broad_query_bigarrow_left_dark;
			} else if (currentPage == totalPages) {
				indicator.parentNode.getElementsByClassName("css_page_down_img")[0].src = movie_broad_query_bigarrow_right;
			}
		} else if (targetClassName == "css_page_down_img" && currentPage < totalPages) {
			if (type == releasedType && !isObtainPlayingDataComplete && !isNextPageFull(type, currentPage + 1)) {
				updateLoadingStatus(indicator, type, currentPage + 1, totalPages);
				return;
			} else if (type == beReleaseType && !isObtainCommingDataComplete && !isNextPageFull(type, currentPage + 1)) {
				updateLoadingStatus(indicator, type, currentPage + 1, totalPages);
				return;
			}

			if (type == releasedType && !isNextPageFull(type, currentPage + 1) && releasedCurrentServerPage < releasedTotalServerPages && isNetStateOk == "false") {
				updateLoadingStatus(indicator, type, currentPage + 1, totalPages);
				getDataFromServer(type, parseInt(releasedCurrentServerPage) + 1, releasedData.data.dataSourceId, releasedData.data.dataSourceName);
				isObtainPlayingDataComplete = false;
				return;
			} else if (type == beReleaseType && !isNextPageFull(type, currentPage + 1) && bereleaseCurrentServerPage < bereleaseTotalServerPages && isNetStateOk == "false") {
				updateLoadingStatus(indicator, type, currentPage + 1, totalPages);
				getDataFromServer(type, parseInt(bereleaseCurrentServerPage) + 1, bereleaseData.data.dataSourceId, bereleaseData.data.dataSourceName);
				isObtainCommingDataComplete = false;
				return;
			}

			var nextPageData = getDataFromCache(type, currentPage + 1);
			if (nextPageData != undefined && nextPageData != null && nextPageData.movies.length != 0) {
				setContentItemsValue(type, nextPageData);
				exec(videoTaskHandler, 'statistic', ["PAGGING_CLICKED"]);
				indicator.innerText = (currentPage + 1) + "/" + totalPages;
				if (currentPage + 1 == totalPages) {
					targetElement.src = movie_broad_query_bigarrow_right_dark;
				} else if (currentPage == 1) {
					indicator.parentNode.getElementsByClassName("css_page_up_img")[0].src = movie_broad_query_bigarrow_left;
				}
			}
		}
		event.stopPropagation();
	}

	function isNextPageFull(pageType, page) {
		var pageLastItem;
		var end = page * defaultItems;
		switch(pageType) {
			case releasedType:
				pageLastItem = releasedData.data.movies[end - 1];
				break;
			case beReleaseType:
				pageLastItem = bereleaseData.data.movies[end - 1];
				break;
		}
		if (pageLastItem == null || pageLastItem == undefined) {
			return false;
		} else {
			return true;
		}
	}

	function updateLoadingStatus(indicator, pageType, nextPage, totalPages) {
		if (pageType == releasedType) {
			if (isNeedLoadNextPalyingPage) {
				return;
			}
			document.getElementById("id_released_content_container").getElementsByClassName("css_movie_items_div")[0].style.display = "none";
			document.getElementById("id_palying_dialog").style.display = "block";
			showMoviesDecription(pageType, "loading");
			var canvas_target = document.getElementById("id_playing_canvas");
			palying_loading_update_id = startRotate(canvas_target);
			isNeedLoadNextPalyingPage = true;
			beLoadPalyingPage = nextPage;
			indicator.innerText = nextPage + "/" + totalPages;
			if (nextPage == totalPages) {
				indicator.parentNode.getElementsByClassName("css_page_down_img")[0].src = movie_broad_query_bigarrow_right_dark;
			}
			beLoadType = pageType;
		} else if (pageType == beReleaseType) {
			if (isNeedLoadNextCommingPage) {
				return;
			}
			document.getElementById("id_berelease_content_container").getElementsByClassName("css_movie_items_div")[0].style.display = "none";
			document.getElementById("id_comming_dialog").style.display = "block";
			showMoviesDecription(pageType, "loading");
			var canvas_target = document.getElementById("id_comming_canvas");
			comming_loading_update_id = startRotate(canvas_target);
			isNeedLoadNextCommingPage = true;
			beLoadCommingPage = nextPage;
			indicator.innerText = nextPage + "/" + totalPages;
			if (nextPage == totalPages) {
				indicator.parentNode.getElementsByClassName("css_page_down_img")[0].src = movie_broad_query_bigarrow_right_dark;
			}
			beLoadType = pageType;
		}
	}

	function showMoviesDecription(pageType, movies_decription) {
		log("current des:" + movies_decription);
		if (pageType == releasedType) {
			if (movies_decription == "loading") {
				document.getElementById("id_playing_canvas").style.display = "inline-block";
				document.getElementById("id_palying_refresh").style.display = "none";
				document.getElementById("id_palying_failertext").style.display = "none";
			} else {
				document.getElementById("id_playing_canvas").style.display = "none";
				document.getElementById("id_palying_refresh").style.display = "none";
				document.getElementById("id_palying_failertext").style.display = "block";
			}
		} else if (pageType == beReleaseType) {
			if (movies_decription == "loading") {
				document.getElementById("id_comming_canvas").style.display = "inline-block";
				document.getElementById("id_comming_refresh").style.display = "none";
				document.getElementById("id_comming_failertext").style.display = "none";
			} else {
				document.getElementById("id_comming_canvas").style.display = "none";
				document.getElementById("id_comming_refresh").style.display = "none";
				document.getElementById("id_comming_failertext").style.display = "block";
			}
		}

	}

	var isNetStateOk = "true";
	function updateNetState(isNetOk, cmd) {
		if (isNetOk == "false") {
			if (cmd == "video_nowplaying") {
				isObtainPlayingDataComplete = true;
				document.getElementById("id_palying_failertext").innerText = "网络未打开，请检查网络设置";
				if (palying_loading_update_id != null) {
					showMoviesDecription(releasedType);
				}
			} else if (cmd == "video_coming") {
				isObtainCommingDataComplete = true;
				document.getElementById("id_comming_failertext").innerText = "网络未打开，请检查网络设置";
				if (comming_loading_update_id != null) {
					showMoviesDecription(beReleaseType);
				}
			}
		} else {
			if (cmd == "video_nowplaying") {
				// 上一次为网络未打开
				if (isNetStateOk == "false") {
					showMoviesDecription(releasedType, "loading");
				}
				document.getElementById("id_palying_failertext").innerText = "网络连接超时，请稍后重试";
				//document.getElementById("id_palying_refresh").style.display = "inline-block";
			} else if (cmd == "video_coming") {
				// 上一次为网络未打开
				if (isNetStateOk == "false") {
					showMoviesDecription(beReleaseType, "loading");
				}
				document.getElementById("id_comming_failertext").innerText = "网络连接超时，请稍后重试";
				//document.getElementById("id_comming_refresh").style.display = "inline-block";
			}
		}
		isNetStateOk = isNetOk;
	}

	function networkOpened(cmd) {
		if (cmd == "video_nowplaying") {
			document.getElementById("id_palying_failertext").innerText = "网络已连接，请刷新重试";
			document.getElementById("id_palying_refresh").style.display = "inline-block";
		} else if (cmd == "video_coming") {
			document.getElementById("id_comming_failertext").innerText = "网络已连接，请刷新重试";
			document.getElementById("id_comming_refresh").style.display = "inline-block";
		}
	}

	/**
	 * 保存从服务端获取的数据
	 */
	function storeNextPageData(nextPageData) {
		var dataType = nextPageData.type;
		var moviesData = nextPageData.movies;
		switch (dataType) {
			case releasedType:
				var storeMoviesData = releasedData.data.movies;
				var length = storeMoviesData.length;
				var nextPageDataLength = moviesData.length;
				for (var i = 0; i < nextPageDataLength; i++) {
					releasedData.data.movies[length + i] = moviesData[i];
				}
				releasedCurrentServerPage = nextPageData.currentServerPage;
				releasedData.data.currentServerPage = nextPageData.currentServerPage;
				break;
			case beReleaseType:
				var storeMoviesData = bereleaseData.data.movies;
				var length = storeMoviesData.length;
				var nextPageDataLength = moviesData.length;
				for (var i = 0; i < nextPageDataLength; i++) {
					bereleaseData.data.movies[length + i] = moviesData[i];
				}
				bereleaseCurrentServerPage = nextPageData.currentServerPage;
				bereleaseData.data.currentServerPage = nextPageData.currentServerPage;
				break;
		}
	}

	/**
	 * 获取服务端指定页的数据
	 */
	function getDataFromServer(type, page, dataSourceId, dataSourceName) {
		if (type == releasedType && !isObtainPlayingDataComplete) {
			return;
		} else if (type == beReleaseType && !isObtainCommingDataComplete) {
			return;
		}
		var cmd;
		if (type == releasedType) {
			cmd = "video_nowplaying";
		} else if (type == beReleaseType) {
			cmd = "video_coming";
		}
		exec(videoTaskHandler, 'loadNextServerPage', [cmd, dataSourceId, dataSourceName, page]);

	}

	/**
	 * 二次取数回调函数
	 */
	function callbackJsWithData(data) {
		var dataJson = eval('(' + data + ')');
		var mockData = {
			"movies" : []
		};
		var playing = dataJson.data.nowplaying;
		var comming = dataJson.data.coming;
		var serverMovies;
		if (playing != undefined && playing != null) {
			mockData.type = releasedType;
			mockData.currentServerPage = dataJson.data.nowplaying.currentServerPage;
			serverMovies = dataJson.data.nowplaying.movies;
		} else if (comming != undefined && comming != null) {
			mockData.type = beReleaseType;
			mockData.currentServerPage = dataJson.data.coming.currentServerPage;
			serverMovies = dataJson.data.coming.movies;
		} else {
			// 此种情况什么发生么？
			completeStoreData();
			isObtainPlayingDataComplete = true;
			isObtainCommingDataComplete = true;
			return;
		}
		if (serverMovies == undefined || serverMovies == null) {
			log("数据为空！");
			return;
		}
		for (var i = 0; i < serverMovies.length; i++) {
			mockData.movies[i] = serverMovies[i];
		}
		if (mockData != undefined && mockData != null && mockData.movies.length > 0) {
			storeNextPageData(mockData);
			if (mockData.type == releasedType) {
				isObtainPlayingDataComplete = true;
			} else if (mockData.type == beReleaseType) {
				isObtainCommingDataComplete = true;
			}
			completeStoreData(mockData.type);
		}
	}

	function completeStoreData(type) {
		if (type == releasedType) {
			stopRotate(palying_loading_update_id);
			palying_loading_update_id = null;
			document.getElementById("id_released_content_container").getElementsByClassName("css_movie_items_div")[0].style.display = "block";
			document.getElementById("id_palying_dialog").style.display = "none";
			if (isNeedLoadNextPalyingPage) {
				if (beLoadType == type) {
					var nextPageData = getDataFromCache(beLoadType, beLoadPalyingPage);
					if (nextPageData != undefined && nextPageData != null && nextPageData.movies.length != 0) {
						setContentItemsValue(type, nextPageData);
					}
				}
				isNeedLoadNextPalyingPage = false;
			}
		} else if (type == beReleaseType) {
			stopRotate(comming_loading_update_id);
			comming_loading_update_id = null;
			document.getElementById("id_berelease_content_container").getElementsByClassName("css_movie_items_div")[0].style.display = "block";
			document.getElementById("id_comming_dialog").style.display = "none";
			if (isNeedLoadNextCommingPage) {
				if (beLoadType == type) {
					var nextPageData = getDataFromCache(beLoadType, beLoadCommingPage);
					if (nextPageData != undefined && nextPageData != null && nextPageData.movies.length != 0) {
						setContentItemsValue(type, nextPageData);
					}
				}
				isNeedLoadNextCommingPage = false;
			}
		} else {
			stopRotate(comming_loading_update_id);
			document.getElementById("id_released_content_container").getElementsByClassName("css_movie_items_div")[0].style.display = "block";
			document.getElementById("id_palying_dialog").style.display = "none";
			document.getElementById("id_berelease_content_container").getElementsByClassName("css_movie_items_div")[0].style.display = "block";
			document.getElementById("id_comming_dialog").style.display = "none";
		}

	}

	function netError(cmd) {
		isNetStateOk = "false";
		if (cmd == "video_nowplaying") {
			showMoviesDecription(releasedType);
			isObtainPlayingDataComplete = true;
			document.getElementById("id_palying_refresh").style.display = "inline-block";
			document.getElementById("id_palying_failertext").innerText = "网络连接超时，请稍后重试";
		} else if (cmd == "video_coming") {
			showMoviesDecription(beReleaseType);
			isObtainCommingDataComplete = true;
			document.getElementById("id_comming_refresh").style.display = "inline-block";
			document.getElementById("id_comming_failertext").innerText = "网络连接超时，请稍后重试";
		}
	}


	window.movieView = window.movieView || {};
	movieView.callbackJsWithData = callbackJsWithData;
	movieView.updateNetState = updateNetState;
	movieView.netError = netError;
	movieView.networkOpened = networkOpened;
	/**
	 * 从已经保存的数据中获取指定页的数据，每页4条
	 * 须根据 type 从对应类型缓存中取数据
	 */
	function getDataFromCache(type, page) {
		var pageData;
		switch(type) {
			case releasedType:
				var start = (page - 1) * defaultItems;
				var end = page * defaultItems;
				pageData = subJson(releasedData.data, start, end);
				break;
			case beReleaseType:
				var start = (page - 1) * defaultItems;
				var end = page * defaultItems;
				pageData = subJson(bereleaseData.data, start, end);
				break;
		}
		return pageData;
	}

	/**
	 *截取指定json数据
	 */
	function subJson(jsonData, start, end) {
		var subData = {
			"movies" : []
		};
		subData.type = jsonData.type;
		var dataSourceId = jsonData.dataSourceId;
		var dataSourceName = jsonData.dataSourceName;
		var tempMovies = jsonData.movies;
		for (var i = start; i < end; i++) {
			var movieItem = tempMovies[i];
			if (movieItem == undefined || movieItem == null) {
				continue;
			}
			subData.movies[i % 4] = movieItem;
		}
		var nextPageLastItem = tempMovies[end + 15];
		log("nextPageLastItem == " + nextPageLastItem);
		if (nextPageLastItem == undefined || nextPageLastItem == null) {
			if (jsonData.type == releasedType && isObtainPlayingDataComplete && releasedCurrentServerPage < releasedTotalServerPages) {
				getDataFromServer(jsonData.type, parseInt(releasedCurrentServerPage) + 1, dataSourceId, dataSourceName);
				isObtainPlayingDataComplete = false;
			} else if (jsonData.type == beReleaseType && isObtainCommingDataComplete && bereleaseCurrentServerPage < bereleaseTotalServerPages) {
				getDataFromServer(jsonData.type, parseInt(bereleaseCurrentServerPage) + 1, dataSourceId, dataSourceName);
				isObtainCommingDataComplete = false;
			}
		}

		return subData;
	}

	/**
	 * 创建电影星级
	 */
	function createStars(level) {
		var stars = document.createElement("div");
		stars.className = "css_stars_div";
		for (var i = 1; i <= 5; i++) {
			var starImg = document.createElement("img");
			starImg.src = (i <= level) ? movie_broad_query_lightstart : (i <= parseFloat(level) + 0.5) ? movie_broad_query_half_lightstart : movie_broad_query_darkstart;
			stars.appendChild(starImg);
		}
		return stars;
	}

	/**
	 *创建TAB按钮
	 */
	function createTopMenus() {
		var menus = document.createElement("ul");
		var menu_left = document.createElement("li");
		menu_left.className = "css_menu_selected_tag";
		menu_left.style.borderRight = "#D8D8D8 1px solid";
		menu_left.innerText = "正在热映";
		var menu_right = document.createElement("li");
		menu_right.innerText = "即将上映";
		// 添加事件处理
		menu_left.addEventListener("touchend", function() {
			handleTouchEvent(this, movie_items_content_hidden_flag);
		}, false);
		menu_right.addEventListener("touchend", function() {
			handleTouchEvent(this, movie_items_content_hidden_flag);
		}, false);
		// 组装menus
		menus.appendChild(menu_left);
		menus.appendChild(menu_right);
		return menus;
	}

	/**
	 * 处理Touchstart事件
	 */
	function handleTouchEvent(obj, contentTag) {
		if (obj.className == "css_menu_selected_tag")
			return;
		var arrayLi = obj.parentNode.getElementsByTagName("li");
		var arrayDiv = document.getElementsByClassName(contentTag);
		var arrayLen = arrayLi.length;
		for (var i = 0; i < arrayLen; i++) {
			if (arrayLi[i] == obj) {
				arrayLi[i].className = "css_menu_selected_tag";
				arrayDiv[i].id = movie_items_content_show_flag;
				if (i == 1) {
					exec(videoTaskHandler, 'statistic', ["COMMING_CLICKED"]);
				}
			} else {
				arrayLi[i].className = "";
				arrayDiv[i].id = "";
			}
		}
	}

	///////////////////////////宽泛查询页面结束///////////////////////////

	///////////////////////////具体查询页面开始///////////////////////////
	/**
	 * 创建具体查询界面
	 * @param {Object} data
	 */
	function createMovieSpecificQueryView(data) {
		// 删除老的View
		if (oldSpecificQueryView != null && oldSpecificQueryView.parentNode == document.body) {
			removeChild(document.body, oldSpecificQueryView);
			// 调用java函数释放底层资源
			// exec(*, *, *);
		}
		var outDiv = createOutDiv();
		if (enableAnimation && isChangingSkin == false) {
			outDiv.className += " css_dialog_opacity_animation";
		}
		var specific_query_view_container = document.createElement("div");
		specific_query_view_container.className = "css_specific_query_view_container_div";
		var topPart = document.createElement("div");
		topPart.className = "css_top_part_div";
		// 电影主要信息 包括：海报、星级、主演、导演
		var movieMainInfo = document.createElement("div");
		movieMainInfo.className = "css_movie_main_info_div";
		var mainInfoLeft = document.createElement("div");
		mainInfoLeft.className = "css_main_info_left_div";
		var filmPoster = document.createElement("img");
		filmPoster.className = "css_specific_film_poster_img";
		filmPoster.src = data.filmPoster;
		filmPoster.addEventListener("error", function() {
			this.src = movie_broad_filmposter_default;
		}, false);
		mainInfoLeft.appendChild(filmPoster);

		var mainInfoRight = document.createElement("div");
		mainInfoRight.className = "css_main_info_right_div";
		var movieName = document.createElement("div");
		movieName.className = "css_specific_movie_name_div";
		movieName.innerText = data.name;
		movieName.id = data.detailUrl;
		var movieStarAndGrade = document.createElement("div");
		movieStarAndGrade.className = "css_movie_star_grade_div";
		var stars = createStars(data.level);
		stars.className = movie_stars_class_name;
		var grade = document.createElement("label");
		grade.className = movie_grade_class_name;
		grade.innerText = data.grade;
		movieStarAndGrade.appendChild(stars);
		movieStarAndGrade.appendChild(grade);

		var movieDirector = document.createElement("label");
		movieDirector.className = "css_movie_director_label";
		movieDirector.innerText = "导演：" + data.director;

		var movieActors = document.createElement("div");
		movieActors.className = "css_movie_actors_div";

		var actorsLabel = document.createElement("label");
		actorsLabel.className = "css_actors_label";
		actorsLabel.innerText = "主演：";
		var actorsList = document.createElement("div");
		actorsList.className = "css_actors_list_div";
		actorsList.innerHTML = setActorList(data.actors);
		var mainInfoLinkImg = createLinkImg();
		mainInfoLinkImg.className = "css_main_info_link_img";

		movieActors.appendChild(actorsLabel);
		movieActors.appendChild(actorsList);
		movieActors.appendChild(mainInfoLinkImg);

		mainInfoRight.appendChild(movieName);
		mainInfoRight.appendChild(movieStarAndGrade);
		mainInfoRight.appendChild(movieDirector);
		mainInfoRight.appendChild(movieActors);

		movieMainInfo.appendChild(mainInfoLeft);
		movieMainInfo.appendChild(mainInfoRight);

		// 电影简介
		var movieInfoWithBaseline = document.createElement("div");
		var movieInfo = document.createElement("div");
		movieInfo.className = "css_movie_info_div";
		movieInfo.innerText = "简介：" + data.info;

		var movieInfoBaseLine = document.createElement("div");
		movieInfoBaseLine.className = "css_movie_info_baseline_div";
		movieInfoWithBaseline.appendChild(movieInfo);
		movieInfoWithBaseline.appendChild(movieInfoBaseLine);

		topPart.appendChild(movieMainInfo);
		topPart.appendChild(movieInfoWithBaseline);
		var topPartTouchObj = createHandleTouchObject("css_top_part_div", "css_specific_movie_name_div");
		enableScrollTouchEvent(topPart, 15, topPartTouchObj);
		videoTaskHandler = data.taskHandler;
		topPart.addEventListener("scrolltouch", function() {
			exec(videoTaskHandler, 'statistic', ["DETAILS_CLICKED"]);
			exec(videoTaskHandler, 'launcherFilm', [topPartTouchObj.returnArgument]);
		}, false);

		// 短评
		var movieShotCommentWithBaseline = document.createElement("div");
		movieShotCommentWithBaseline.className = "css_movie_shot_comment_with_baseline_div";
		var movieShotComment = document.createElement("div");
		movieShotComment.className = "css_movie_shot_comment_div";
		var shotCommentLabel = document.createElement("label");
		shotCommentLabel.className = "css_shot_comment_label";
		var shotComment = parseInt(data.shotComment);
		shotCommentLabel.innerText = "豆瓣短评（全部" + shotComment + "条）";
		if (shotComment != 0) {
			var shotCommentLinkImg = createLinkImg();
			shotCommentLinkImg.className = "css_shot_comment_link_img";
			shotCommentLinkImg.id = data.shotCommentUrl;
			movieShotComment.appendChild(shotCommentLinkImg);
		} else {
			shotCommentLabel.style.color = "#bbbbbb";
		}

		movieShotComment.appendChild(shotCommentLabel);
		var shotCommentBaseLine = document.createElement("div");
		shotCommentBaseLine.className = "css_movie_info_baseline_div";
		movieShotCommentWithBaseline.appendChild(movieShotComment);
		movieShotCommentWithBaseline.appendChild(shotCommentBaseLine);

		var movieShotCommentTouchObj = createHandleTouchObject("css_movie_shot_comment_with_baseline_div", "css_shot_comment_link_img");
		enableScrollTouchEvent(movieShotCommentWithBaseline, 15, movieShotCommentTouchObj);
		movieShotCommentWithBaseline.addEventListener("scrolltouch", function() {
			exec(videoTaskHandler, 'statistic', ["SHOTCOMMENT_CLICKED"]);
			exec(videoTaskHandler, 'launcherShotComment', [movieShotCommentTouchObj.returnArgument]);
		}, false);

		// 影评
		var movieContentWithoutBaseline = document.createElement("div");
		movieContentWithoutBaseline.className = "css_movie_content_without_baseline_div";
		var movieComment = document.createElement("div");
		movieComment.className = "css_movie_comment_div";
		var moiveComment = parseInt(data.comment);
		var commentLabel = document.createElement("label");
		commentLabel.innerText = "豆瓣影评（全部" + moiveComment + "条）";
		if (moiveComment != 0) {
			var commentLinkImg = createLinkImg();
			commentLinkImg.className = "css_comment_link_img";
			commentLinkImg.id = data.commentUrl;
			movieComment.appendChild(commentLinkImg);
		} else {
			commentLabel.style.color = "#bbbbbb";
		}

		movieComment.appendChild(commentLabel);
		movieContentWithoutBaseline.appendChild(movieComment);
		var movieCommentTouchObj = createHandleTouchObject("css_movie_content_without_baseline_div", "css_comment_link_img");
		enableScrollTouchEvent(movieContentWithoutBaseline, 15, movieCommentTouchObj);
		movieContentWithoutBaseline.addEventListener("scrolltouch", function() {
			exec(videoTaskHandler, 'statistic', ["COMMENT_CLICKED"]);
			exec(videoTaskHandler, 'launcherMovieContent', [movieCommentTouchObj.returnArgument]);
		}, false);

		////////组装
		specific_query_view_container.appendChild(topPart);
		specific_query_view_container.appendChild(movieShotCommentWithBaseline);
		specific_query_view_container.appendChild(movieContentWithoutBaseline);
		//specific_query_view_container.appendChild(bottomBlankArea);

		outDiv.appendChild(specific_query_view_container);

		document.body.appendChild(outDiv);
		showOpacityAnimation(outDiv, 150);
		oldSpecificQueryView = outDiv;
		exec(videoTaskHandler, 'statistic', ["SHOW_DETAIL"]);
		return outDiv;

	}

	/**
	 * 设置演员列表，如果多于三个只保留三个
	 */
	function setActorList(actorsStr) {
		var actorArray = actorsStr.split(",,");
		var length = actorArray.length;
		log("actorArray.length = " + length);
		length = length > 3 ? 3 : length;
		var htmlStr = "";
		for (var i = 0; i < length; i++) {
			htmlStr += (i != length - 1 ? actorArray[i] + "<br>" : actorArray[i]);
			log("i = " + htmlStr);
		}
		return htmlStr;
	}

	/**
	 * 生成链接引导小图标
	 */
	function createLinkImg() {
		var linkImg = document.createElement("img");
		linkImg.src = dialog_goto_right_icon;
		return linkImg;
	}

	///////////////////////////具体查询页面结束///////////////////////////

	///////////////////////共用函数

	/**
	 * 生成touch事件处理对象
	 */
	function createHandleTouchObject(parentElementClassName, returnElementClassName) {
		var touchObj = new Object;
		touchObj.returnArgument = null;
		touchObj.touchElement = null;

		touchObj.touchStart = function(event) {
			this.touchElement = event.target;
			this.touchElement = getParentOfClass(parentElementClassName, this.touchElement);
			// this.touchElement.style.background = "#BCD5EF";
			if (this.touchElement != null && this.touchElement != undefined) {
				this.touchElement.style.background = "url('" + list_item_background_pressed + "')";
			}
		};
		touchObj.touchMove = function() {
			if (this.touchElement !== null) {
				this.touchElement.style.background = "";
			}

		};
		touchObj.touchEnd = function() {
			if (this.touchElement != null) {
				this.touchElement.style.background = "";
				this.returnArgument = this.touchElement.getElementsByClassName(returnElementClassName);
				log("touchElement.toStriing === " + this.returnArgument.toString());
				if (this.returnArgument != undefined && this.returnArgument != null) {
					this.returnArgument = this.returnArgument[0].id;
				}
			}
			this.touchElement = null;
		}

		return touchObj;
	}

	function enableScrollTouchEvent(target, scrollLength, touchObj) {
		if (target == null || target == undefined) {
			return;
		}
		if (scrollLength == undefined) {
			scrollLength = 15;
		}
		var myEvent = document.createEvent("Event");
		// 事件名称：scrolltouch;是否冒泡:true;是否可取消：true;
		myEvent.initEvent("scrolltouch", true, true);
		var target_start_pageY = 0;
		var target_end_pageY = 0;
		var target_have_move_motion = false;
		target.addEventListener("touchstart", function() {
			target_have_move_motion = false;
			event.stopPropagation();
			touchObj.touchStart(event);
			var touchPoint = event.targetTouches[0];
			target_start_pageY = touchPoint.pageY;
		});
		target.addEventListener("touchmove", function() {
			event.stopPropagation();
			touchObj.touchMove();
			var touchPoint = event.targetTouches[0];
			target_end_pageY = touchPoint.pageY;
			if (!target_have_move_motion) {
				if (Math.abs(target_end_pageY - target_start_pageY) > scrollLength) {
					target_have_move_motion = true;
					touchObj.returnArgument = null;
				}
			}
		});
		target.addEventListener("touchend", function() {
			event.stopPropagation();
			touchObj.touchEnd();
			if (!target_have_move_motion && touchObj.returnArgument != null) {
				target.dispatchEvent(myEvent);
			}
			target_start_pageY = 0;
			target_end_pageY = 0;
			target_have_move_motion = false;
			touchObj.touchElement = null;
			touchObj.returnArgument = null;
		});
	}

	/**
	 * 输出log
	 * @param {Object} str
	 */
	function log(str) {
		console.log(str);
	}

	return showMovieView;
});
