/**
 * 搜狐新闻视图
 *
 * @author ppfeng
 * 2013-4-28
 *
 */
define(function() {
	/**
	 * 创建新闻界面控制播放按钮
	 *
	 * @param btnImgSrc
	 *            按钮图片地址，字符串类型
	 * @param btnId
	 *            按钮ID
	 */
	function createNewsControlBtn(btnImgSrc, btnId) {
		var btnImg = document.createElement("img");
		btnImg.src = btnImgSrc;
		btnImg.id = btnId;
		btnImg.className = "css_dialog_news_control_btn_img";
		return btnImg;
	}

	var news_view_state = "";
	var newsContentScroller = null;
	var news_view_loading_update_id = null;
	var sohu_news_taskHandler;
	var curShowNewsCount = 5; //新闻每页的固定条目数
	var curPage = 1;
	var next_over = false;
	function createNewsView(newsInfo) {
		news_view_state = "play";
		isNewsRunning = false;
		curPage = 1;
		next_over = false;

		var newsTaskHandler = newsInfo.taskHandler;
		sohu_news_taskHandler = newsTaskHandler;

		var outDiv = createOutDiv(newsTaskHandler);
		if (enableAnimation && isChangingSkin == false) {
			outDiv.className += " css_dialog_opacity_animation";
		}

		// loading 状态下的显示元素
		var dialog_news_loading_div = document.createElement("div");
		dialog_news_loading_div.id = "id_news_loading_div";
		//测试
		// dialog_news_loading_div.style.opacity = "0.0";

		dialog_news_loading_div.style.display = "none";
		dialog_news_loading_div.className = "css_dialog_sohu_news_loading";

		// loading使用canvas模拟
		var dialog_news_loading_canvas = document.createElement("canvas");
		dialog_news_loading_canvas.id = "id_news_loading_canvas";
		// FIXME 暂时借用dialog_title_canvas_height的值作为canvas的宽、高，后续使用独立的变量
		dialog_news_loading_canvas.setAttribute("width", dialog_title_canvas_height + "px");
		dialog_news_loading_canvas.setAttribute("height", dialog_title_canvas_height + "px");
		dialog_news_loading_canvas.className = "css_dialog_news_loading_canvas";
		//测试
		//dialog_news_loading_canvas.style.display = "none";

		//加载失败外层div
		var loading_fail_wrapper = document.createElement("div");
		loading_fail_wrapper.className = "css_sohu_loading_fail_wrapper";
		
		//加载失败描述文本
		var dialog_news_loading_failertext = document.createElement("div");
		dialog_news_loading_failertext.setAttribute("id", "id_news_loading_failer");
		dialog_news_loading_failertext.className = "css_dialog_sohu_news_loading_failertext";
		dialog_news_loading_failertext.innerText = "信息提示";
		//测试
		//dialog_news_loading_failertext.style.display = "inline-block";
		
		//加载失败图片
		var loading_fail_img = document.createElement("img");
		loading_fail_img.src = dialog_stock_refresh;
		loading_fail_img.className = "css_sohu_failure_refresh_image";
		loading_fail_img.id = "id_sohu_loading_fail_img";
		//测试
		//loading_fail_img.style.display = "inline-block";
		
		loading_fail_wrapper.appendChild(dialog_news_loading_failertext);
		loading_fail_wrapper.appendChild(loading_fail_img);

		// 新闻主体div
		var dialog_news_inner_div = document.createElement("div");
		dialog_news_inner_div.className = "css_dialog_news_inner";

		// title区域
		var dialog_news_title = document.createElement("div");
		dialog_news_title.className = "css_dialog_sohu_news_title";

		var dialog_news_title_text = document.createElement("label");
		dialog_news_title_text.className = "css_dialog_sohu_news_title_text";
		if((newsInfo.sohuNewsTitle != "") && (newsInfo.sohuNewsTitle != null) && ( typeof newsInfo.sohuNewsTitle != "undefined") ){
			dialog_news_title_text.innerText = newsInfo.sohuNewsTitle;
		}else{
			dialog_news_title_text.innerText = "今日要闻";
		}
		

		//分享按钮
		var shareDiv = createSharePlayView(newsInfo.taskHandler, true, 2);
		shareDiv.className = "css_dialog_sohu_news_sharePlayDiv";

		dialog_news_title.appendChild(dialog_news_title_text);
		dialog_news_title.appendChild(shareDiv);

		// 新闻内容区域主容器
		var dialog_news_content_main_div = document.createElement("div");
		dialog_news_content_main_div.className = "css_dialog_sohu_content_main_div";

		var dialog_news_content_wrapper = document.createElement("div");
		dialog_news_content_wrapper.className = "css_dialog_sohu_news_content_wrapper";
		dialog_news_content_wrapper.id = "id_sohu_news_content_wrapper";
		//测试
		//dialog_news_content_wrapper.style.opacity = "0.0";

		// 新闻内容正文区。
		for (var i = 0; i < curShowNewsCount; i++) {
			var item;
			if (i < newsInfo.sohuNewsItems.length) {
				item = createSohuNewsItem("news" + i,
						newsInfo.sohuNewsItems[i].newsTitle,
						newsInfo.sohuNewsItems[i].newsBrief,
						newsInfo.sohuNewsItems[i].newsPic);
			} else {
				//没数据时就显示为空，保证界面每页都是固定的5个新闻条目
				item = createSohuNewsItem("news" + i, "", "", "");
			}
			
			dialog_news_content_wrapper.appendChild(item);

			if (i != curShowNewsCount - 1) {
				dialog_news_content_wrapper.appendChild(createRestaurantDivier());
			}
		}

		dialog_news_content_main_div.appendChild(dialog_news_content_wrapper);

		// 播放控制栏
		var dialog_news_control_div = document.createElement("div");
		dialog_news_control_div.className = "css_dialog_news_control_div";

		var dialog_news_control_btn_div = document.createElement("div");
		dialog_news_control_btn_div.className = "css_dialog_news_control_btn_div";

		var btn_last = createNewsControlBtn(news_btn_last_disable, "id_news_last");
		btn_last.className = btn_last.className + " css_dialog_news_btn_last";

		var btn_play = createNewsControlBtn(news_speaker_status1, "id_news_play_pause");
		btn_play.className = btn_play.className + " css_dialog_news_btn_play";

		var btn_next = createNewsControlBtn(news_btn_next_normal, "id_news_next");
		btn_next.className = btn_next.className + " css_dialog_news_btn_next";

		dialog_news_control_btn_div.appendChild(btn_last);
		dialog_news_control_btn_div.appendChild(btn_play);
		dialog_news_control_btn_div.appendChild(btn_next);

		dialog_news_control_div.appendChild(dialog_news_control_btn_div);

		//查看客户端按钮
		// 按钮容器
		var buttonContainer = document.createElement("div");
		buttonContainer.className = "css_sohu_news_button_container";

		// 保存按钮背景层
		var buttonBgCanvas = createBgCanvas(sohu_news_button_width);
		buttonBgCanvas.className = "css_dialog_absolute_bg";
		buttonBgCanvas.setAttribute("height", sohu_news_button_height + "px");

		// 文字
		var btn_client_download_div = document.createElement("div");
		btn_client_download_div.className = "css_btn_client_download_div";
		btn_client_download_div.innerText = newsInfo.clientText;

		buttonContainer.appendChild(buttonBgCanvas);
		buttonContainer.appendChild(btn_client_download_div);

		dialog_news_inner_div.appendChild(dialog_news_title);
		dialog_news_inner_div.appendChild(dialog_news_content_main_div);
		dialog_news_inner_div.appendChild(dialog_news_control_div);
		dialog_news_inner_div.appendChild(buttonContainer);

		dialog_news_loading_div.appendChild(dialog_news_loading_canvas);
		//测试
		dialog_news_loading_div.appendChild(loading_fail_wrapper);
		//dialog_news_loading_div.appendChild(dialog_news_loading_failertext);

		outDiv.appendChild(dialog_news_loading_div);
		outDiv.appendChild(dialog_news_inner_div);

		document.body.appendChild(outDiv);

		// 按钮的背景图片
		draw(buttonBgCanvas, sohu_brief_button_normal, sohu_brief_button_normal_coordinates);

		showOpacityAnimation(outDiv, 150);
		/**
		 * 添加控制按钮触摸响应函数
		 */
		dialog_news_control_btn_div.addEventListener("touchstart", function() {
			var targetElement = event.target;
			if (targetElement.id === "id_news_last") {
				
				if(curPage <= 1){
					targetElement.src = news_btn_last_disable;
				}else{
						targetElement.src = news_btn_last_pressed;
				}
			}
			else if (targetElement.id === "id_news_play_pause") {
				if (news_view_state == "next_over") {
					targetElement.src = news_speaker_status1;
				} else {//当前不是在最后一页
					if (news_view_state === "pause") {
						targetElement.src = news_speaker_pressed;
					} else {
						targetElement.src = news_speaker_pressed;
					}
				}
			}
			else if (targetElement.id === "id_news_next") {
				if(!next_over){
					if (news_view_state !== "loading" && news_view_state !== "loading_faile") {
						targetElement.src = news_btn_next_pressed;
					}
				}else{
					targetElement.src = news_btn_next_disable;
				}
			}
		}, false);
		dialog_news_control_btn_div.addEventListener("touchend", function() {
			var targetElement = event.target;
			if (targetElement.id === "id_news_last") {
				if(curPage > 1){
					if (news_view_state !== "last_over") {
						targetElement.src = news_btn_last_normal;
						//播放上一页的第一条，并刷新界面
						exec(newsTaskHandler, 'playLastFirstItem', []);
						next_over = false;
					}
				} else if (news_view_state === "loading"
						|| news_view_state === "loading_faile"
						|| news_view_state === "play_faile") {
					targetElement.src = news_btn_last_normal;
					//播放上一页的第一条，并刷新界面
					exec(newsTaskHandler, 'playLastFirstItem', []);
					next_over = false;
				}
			}
			else if (targetElement.id === "id_news_play_pause") {
				if (news_view_state === "pause" || news_view_state == "next_over" || news_view_state == "all_play_over") {
					targetElement.src = news_speaker_status1;
					exec(newsTaskHandler, 'play', []);

				} else {
					targetElement.src = news_speaker_status1;
					exec(newsTaskHandler, 'pause', []);
				}
			}
			else if (targetElement.id === "id_news_next") {
				if(!next_over){
					if (news_view_state !== "next_over" && news_view_state !== "loading" && news_view_state !== "loading_faile") {
						targetElement.src = news_btn_next_normal;
						//播放下一页的第一条，并刷新界面
						exec(newsTaskHandler, 'playNextFirstItem', []);
					}else{
						targetElement.src = news_btn_next_disable;
					}
				}
			}
		}, false);

		var ismove = false;
		buttonContainer.addEventListener("touchstart", function() {
			moveOverCheck.start(event);
			draw(buttonBgCanvas, sohu_brief_button_pressed, sohu_brief_button_pressed_coordinates);
		}, false);

		buttonContainer.addEventListener("touchmove", function() {
			if (moveOverCheck.check(event)) {
				ismove = true;
				draw(buttonBgCanvas, sohu_brief_button_normal, sohu_brief_button_normal_coordinates);
			}
		}, false);

		buttonContainer.addEventListener("touchend", function() {
			draw(buttonBgCanvas, sohu_brief_button_normal, sohu_brief_button_normal_coordinates);
			if (istouchmove == true) {
				istouchmove = false;
			} else {
				exec(newsTaskHandler, 'downloadClient', []);
			}
		}, false);
		
		loading_fail_wrapper.addEventListener("touchend", function() {
			exec(newsTaskHandler, 'refreshPrepareData', []);
		}, false);
		
		
		// 设置当前可删除view
		currentCanDeleteView = outDiv;

		outDiv.refresh = function() {
			update(outDiv.news_state, outDiv.news_description, newsTaskHandler);
		};

		return outDiv;
	}
	
	/**
	 * 回调函数，刷新界面
	 * 1.点击下/上一页，刷新界面。
	 * 2.播放完第5n条，刷新界面。(n=1,2,3……)
	 * 后台记忆当前页码。
	 */
	function onRefreshCurView(jSonObject){
		//获取当前页码
		curPage = jSonObject.pageIndex;
		
		console.log('onRefreshCurView begin, curPage is ' + curPage);
		if(curPage > 1){
			document.getElementById("id_news_last").src = news_btn_last_normal;
		}
		
		for(var i = 0; i < curShowNewsCount; i++){
			var titleid = "newstitle" + i;
			var briefid = "newsbrief" + i;
			var imgid = "newsImg" + i;
			var titlediv = document.getElementById(titleid);
			var briefdiv = document.getElementById(briefid);
			var newsimg = document.getElementById(imgid);
			
            //清空老数据
			if (titlediv) {
				titlediv.innerText = "";
			}
			if (briefdiv) {
				briefdiv.innerText = "";
			}
			if (newsimg) {
				newsimg.style.visibility = "hidden";
			}
			
            //更新数据
			if (i < jSonObject.newsListLength) {
				titlediv.innerText = jSonObject.sohuNewsItems[i].newsTitle;
				var brief = jSonObject.sohuNewsItems[i].newsBrief;
				if(brief.length >= 35){
					brief = brief.substring(0,35) + "…";
				}
				briefdiv.innerText = brief;
				var url = jSonObject.sohuNewsItems[i].newsPic;
				newsimg.style.visibility = "visible";
				newsimg.src = sohu_brief_default_img;
				forceRefreshScreen();
				if (url) {
					newsimg.src = url;
				}else{
					newsimg.src = sohu_brief_default_img;
				}
			}
		}
	}

	function createSohuNewsItem(id, title, brief, url) {
		var itemDiv = document.createElement("div");
		var digital = id.charAt(4);

		itemDiv.id = id;
		itemDiv.className = "css_sohu_item_div";

		var titleAndBriefDiv = document.createElement("div");
		titleAndBriefDiv.className = "css_title_and_brief_div";

		var titleDiv = document.createElement("div");
		titleDiv.className = "css_dialog_sohu_title_div";
		titleDiv.innerText = title;
		titleDiv.id = "newstitle" + digital;
		
		//标题为空时，保证正常显示
		if(title == "" && brief != ""){
			titleDiv.innerHTML = "&nbsp;&nbsp;&nbsp;";
		}

		var briefDiv = document.createElement("div");
		briefDiv.className = "css_dialog_sohu_brief_div";
		//最大显示长度
		if(brief.length >= 35){
			brief = brief.substring(0,35) + "…";
		}
		briefDiv.innerText = brief;
		briefDiv.id = "newsbrief" + digital;

		titleAndBriefDiv.appendChild(titleDiv);
		titleAndBriefDiv.appendChild(briefDiv);

		var newsImg = document.createElement("img");
		newsImg.className = "css_sohu_news_img";
		//newsImg.style.background = "url('" + sohu_img_background + "')";
		newsImg.id = "newsImg" + digital;
		if ((url != "") && (url != null) && ( typeof url != "undefined")) {
			newsImg.src = url;
		} else {
			if(title == "" && brief == ""){
				newsImg.style.visibility = "hidden";
			}else{
				newsImg.style.visibility = "visible";
				newsImg.src = sohu_brief_default_img;
			}
		}
		
		newsImg.onerror = function(){
			newsImg.src = sohu_brief_default_img;
		};

		itemDiv.appendChild(titleAndBriefDiv);
		itemDiv.appendChild(newsImg);

		itemDiv.setAttribute("ontouchstart", "touchstart('" + id + "')");
		itemDiv.setAttribute("ontouchmove", "touchmove('" + id + "')");
		itemDiv.setAttribute("ontouchend", "touchend('" + id + "')");
		return itemDiv;
	}

	var istouchmove = false;
	// 点击新闻列项时是否触发touchmove
	touchstart = function(id) {
		var element2 = document.getElementById(id);
		element2.style.background = "url('" + list_item_background_pressed + "')";

		moveOverCheck.start(event);
		setTimeout(function() {
			recoverBackground(element2);
		}, 5000);
	};
	function recoverBackground(element) {
		element.style.background = "";
	}
	touchmove = function(id) {
		document.getElementById(id).style.background = "";

		if (moveOverCheck.check(event)) {
			istouchmove = true;
		}
	};
	touchend = function(id) {
		document.getElementById(id).style.background = "";
		if (istouchmove == true) {
			istouchmove = false;
		} else {
			console.log("---------------->touchend is going");
			var digital = id.charAt(4);
			exec(sohu_news_taskHandler, 'lookDetail', [digital]);
		}
	};

	function showNewsDecription(news_decription) {
		console.log("current des:" + news_decription);
		// document.getElementById("id_sohu_news_content_wrapper").style.opacity = "0.0";
		// document.getElementById("id_news_loading_div").style.opacity = "1.0";

		document.getElementById("id_sohu_news_content_wrapper").style.display = "none";
		document.getElementById("id_news_loading_div").style.display = "inline-block";
		if (news_decription == "loading") {
			document.getElementById("id_news_loading_canvas").style.display = "inline-block";
			document.getElementById("id_news_loading_failer").style.display = "none";
			document.getElementById("id_sohu_loading_fail_img").style.display = "none";
		} else {
			document.getElementById("id_news_loading_canvas").style.display = "none";
			document.getElementById("id_news_loading_failer").style.display = "inline-block";
		}


	}

	var isNewsRunning = false;
	function update(news_state, news_description, taskHandler) {
		console.log("new  state  is : " + news_state);
		if (news_state == "pause") {
			if(next_over || news_view_state == "next_over"){
				document.getElementById("id_news_next").src = news_btn_next_disable;
			}else{
				document.getElementById("id_news_next").src = news_btn_next_normal;
			}
			document.getElementById("id_news_play_pause").src = news_speaker_status1;
			if(curPage >= 2){
				document.getElementById("id_news_last").src = news_btn_last_normal;
			}
			
		} else if (news_state == "play") {
			if (news_view_state == "last_over") {
				
			} else if (news_view_state == "next_over") {
				document.getElementById("id_news_next").src = news_btn_next_disable;
			} else if (news_view_state == "loading") {
				stopRotate(news_view_loading_update_id);
			} else if (news_view_state == "loading_faile") {
			}
			if(curPage >= 2){
				document.getElementById("id_news_last").src = news_btn_last_normal;
			}
			if(next_over || news_view_state == "next_over"){
				document.getElementById("id_news_next").src = news_btn_next_disable;
			}else{
				document.getElementById("id_news_next").src = news_btn_next_normal;
			}
			document.getElementById("id_news_play_pause").src = news_speaker_status1;
			// document.getElementById("id_news_loading_div").style.opacity = "0.0";
			// document.getElementById("id_sohu_news_content_wrapper").style.opacity = "1.0";
			
			document.getElementById("id_news_loading_div").style.display = "none";
			document.getElementById("id_sohu_news_content_wrapper").style.display = "inline-block";


			if (isNewsRunning == false) {
				setTimeout(function() {
					newsbuffer();
				}, 300);
			}

			if (newsContentScroller != null && newsContentScroller.y != 0) {
				newsContentScroller.scrollTo(0, 0);
			}
			
		} else if (news_state == "last_over") {
			console.log("There is no news ahead");
			document.getElementById("id_news_last").src = news_btn_last_disable;
			document.getElementById("id_news_play_pause").src = news_speaker_status1;
			document.getElementById("id_news_next").src = news_btn_next_normal;
		} else if (news_state == "play_faile") {
			showNewsDecription("play_faile");
			document.getElementById("id_news_play_pause").src = news_speaker_status1;
			document.getElementById("id_news_loading_failer").innerText = news_description;
		} else if (news_state == "next_over") {
			next_over = true;
			if(news_view_state == "play"){
				if (isNewsRunning == false) {
					setTimeout(function() {
						newsbuffer();
					}, 300);
				}
			}
			document.getElementById("id_news_next").src = news_btn_next_disable;
			document.getElementById("id_news_play_pause").src = news_speaker_status1;
			document.getElementById("id_news_last").src = news_btn_last_normal;
			
		} else if (news_state == "loading") {
			document.getElementById("id_news_next").src = news_btn_next_disable;
			document.getElementById("id_news_last").src = news_btn_last_normal;
			document.getElementById("id_news_play_pause").src = news_speaker_status1;
			showNewsDecription("loading");
			var canvas_target = document.getElementById("id_news_loading_canvas");
			news_view_loading_update_id = startRotate(canvas_target);
		} else if (news_state == "loading_faile") {
			console.log("current state is loading_fail");
			document.getElementById("id_news_next").src = news_btn_next_disable;
			document.getElementById("id_news_play_pause").src = news_speaker_status1;
			document.getElementById("id_news_last").src = news_btn_last_normal;
			stopRotate(news_view_loading_update_id);

			console.log("loading_faile:" + news_description);
			showNewsDecription("loading_faile");
			// document.getElementById("id_news_loading_canvas").style.display = "none";
			// document.getElementById("id_news_loading_failer").style.display = "inline-block";

			if(news_description == "true"){
				document.getElementById("id_sohu_loading_fail_img").style.display = "inline-block";
				document.getElementById("id_news_loading_failer").innerText = "网络连接超时，点击重试";
			}else{
				document.getElementById("id_sohu_loading_fail_img").style.display = "none";
				document.getElementById("id_news_loading_failer").innerText = "网络未打开，请检查网络设置";
			}
		}else if(news_state == "all_play_over"){
			
		}
		news_view_state = news_state;

		// 保存数据到dom节点
		var outDiv = document.getElementById(taskHandler);
		outDiv.news_state = news_state;
		if (news_description != null && news_description != "") {
			outDiv.news_description = news_description;
		}
	}

	var news_counter = 0;
	function newsbuffer() {
		var bufferImgArray = [news_speaker_status1, news_speaker_status2, news_speaker_status3];
		news_counter = news_counter % 3;
		document.getElementById("id_news_play_pause").src = bufferImgArray[news_counter];
		news_counter++;
		if (news_view_state == "play" || news_view_state == "next_over") {
			isNewsRunning = true;
			setTimeout(function() {
				newsbuffer();
			}, 300);
		} else {
			isNewsRunning = false;
			document.getElementById("id_news_play_pause").src = news_speaker_status1;
		}
	}

	// 将需要java回调的函数暴露到全局对象sohuNewsView中，方便外部java文件调用
	window.sohuNewsView = window.sohuNewsView || {};
	console.log(sohuNewsView);
	sohuNewsView.update = update;
	sohuNewsView.onRefreshCurView = onRefreshCurView;

	return createNewsView;
});
